﻿Imports System.IO
Imports org.apache.pdfbox.pdmodel
Imports org.apache.pdfbox.util


Public Class Form1

    Dim sciezkaFolderu As String

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click

        Dim result As DialogResult = FolderBrowserDialog1.ShowDialog()

        If (result = DialogResult.OK) Then
            With FolderBrowserDialog1
                sciezkaFolderu = .SelectedPath
            End With

        End If
        Label1.Text = sciezkaFolderu
        WylistujPlikiPdf(sciezkaFolderu)
    End Sub

    Dim ListaPlikow As New List(Of List(Of String))

    Private Sub WylistujPlikiPdf(ByVal Sciezka As String)
        ListBox1.Items.Clear()

        Dim extension As New List(Of String)
        extension.Add("*.pdf")
        extension.Add("*.txt")

        If System.IO.Directory.Exists(Sciezka) Then
            For i As Integer = 0 To extension.Count - 1
                Dim Nowa_Lista As New List(Of String)
                For Each file In My.Computer.FileSystem.GetFiles(Sciezka, FileIO.SearchOption.SearchTopLevelOnly, extension(i))
                    ListBox1.Items.Add(My.Computer.FileSystem.GetName(file))
                    Nowa_Lista.Add(file)
                Next
                ListaPlikow.Add(Nowa_Lista)
            Next
        Else
            MsgBox("Ścieżka do folderu nie istnieje.")
        End If
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        If Not TextBox1.Text = "" Then
            ListBox1.Items.Clear()
            przeszukajPlikiTxT(ListaPlikow(1))
            przeszukajPlikiPdf(ListaPlikow(0))
        Else
            MsgBox("Nie wpisałeś szukanej frazy!")
        End If
    End Sub

    Private Sub przeszukajPlikiTxT(ByRef ListaPlikowTxt As List(Of String))
        If ListaPlikowTxt.Count > 0 Then
            For i As Integer = 0 To ListaPlikowTxt.Count - 1
                Dim tekst As String
                If System.IO.File.Exists(ListaPlikowTxt(i)) Then
                    tekst = File.ReadAllText(ListaPlikowTxt(i))
                    Dim slowa As String()
                    slowa = tekst.Split(" ")
                    For j = 0 To slowa.Length() - 1
                        If slowa(j).ToString.ToUpper = TextBox1.Text.ToUpper Then
                            ListBox1.Items.Add(My.Computer.FileSystem.GetName(ListaPlikowTxt(i)))
                            Exit For
                        End If
                    Next
                End If
            Next
        End If
    End Sub

    Private Sub przeszukajPlikiPdf(ByRef ListaPlikowPdf As List(Of String))
        If ListaPlikowPdf.Count > 0 Then
            For i As Integer = 0 To ListaPlikowPdf.Count - 1
                Dim tekst As String
                If System.IO.File.Exists(ListaPlikowPdf(i)) Then
                    tekst = parseUsingPDFBox(ListaPlikowPdf(i))
                    If tekst.Contains(TextBox1.Text) Then
                        ListBox1.Items.Add(My.Computer.FileSystem.GetName(ListaPlikowPdf(i)))
                    End If
                End If
            Next
        End If
    End Sub


    Private Shared Function parseUsingPDFBox(ByVal input As String) As String
        Dim doc As PDDocument = Nothing
        Try
            doc = PDDocument.load(input)
            Dim stripper As New PDFTextStripper()
            Return stripper.getText(doc)
        Finally
            If doc IsNot Nothing Then
                doc.close()
            End If
        End Try
    End Function

End Class
